searchNodes=[{"type":"module","title":"DigitalToken","doc":"Functions to validate, search and retrieve digital token data sourced from the DTIF registry .","ref":"DigitalToken.html"},{"type":"function","title":"DigitalToken.get_token/1","doc":"Returns the registry data for a given token identifier. Arguments id is any token identifier or short name Returns {:ok, registry_data} or {:error, {exception, id}} Example DigitalToken . get_token ( &quot;BTC&quot; ) #=&gt; {:ok, % DigitalToken { header : %{ dlt_type : :blockchain , dti : &quot;4H95J0R2X&quot; , dti_type : :native , template_version : # Version &lt; 1.0 . 0 &gt; } , informative : %{ long_name : &quot;Bitcoin&quot; , public_distributed_ledger_indication : false , short_names : [ &quot;BTC&quot; , &quot;XBT&quot; ] , unit_multiplier : 100000000 , url : &quot;https://github.com/bitcoin/bitcoin&quot; } , metadata : % { ... ..","ref":"DigitalToken.html#get_token/1"},{"type":"function","title":"DigitalToken.get_token!/1","doc":"Returns the registry data for a given token identifier. Arguments id is any token identifier or short name Returns registry_data or raises an exception Example DigitalToken . get_token ( &quot;BTC&quot; ) #=&gt; %DigitalToken{ header : %{ dlt_type : :blockchain , dti : &quot;4H95J0R2X&quot; , dti_type : :native , template_version : # Version &lt; 1.0 . 0 &gt; } , informative : %{ long_name : &quot;Bitcoin&quot; , public_distributed_ledger_indication : false , short_names : [ &quot;BTC&quot; , &quot;XBT&quot; ] , unit_multiplier : 100000000 , url : &quot;https://github.com/bitcoin/bitcoin&quot; } , metadata : % { ... ..","ref":"DigitalToken.html#get_token!/1"},{"type":"macro","title":"DigitalToken.is_digital_token/1","doc":"","ref":"DigitalToken.html#is_digital_token/1"},{"type":"function","title":"DigitalToken.long_name/1","doc":"Returns the long name of a digital token. Arguments token_id is any validate digital token identifier. Returns {:ok, long_name} where long_name is the token's registered name. {:error, {exceoption, reason}} Examples iex&gt; DigitalToken . long_name &quot;BTC&quot; { :ok , &quot;Bitcoin&quot; } iex&gt; DigitalToken . long_name &quot;4H95J0R2X&quot; { :ok , &quot;Bitcoin&quot; } iex&gt; DigitalToken . long_name &quot;W0HBX7RC4&quot; { :ok , &quot;Terra Classic&quot; }","ref":"DigitalToken.html#long_name/1"},{"type":"function","title":"DigitalToken.short_name/1","doc":"Returns the short name of a digital token. Arguments token_id is any validate digital token identifier. Returns {:ok, short_name} where short_name is either the first short name in token.informative.short_names or the token long name if there are no short names. {:error, {exceoption, reason}} Examples iex&gt; DigitalToken . short_name &quot;BTC&quot; { :ok , &quot;BTC&quot; } iex&gt; DigitalToken . short_name &quot;4H95J0R2X&quot; { :ok , &quot;BTC&quot; } iex&gt; DigitalToken . short_name &quot;W0HBX7RC4&quot; { :ok , &quot;Terra Classic&quot; }","ref":"DigitalToken.html#short_name/1"},{"type":"function","title":"DigitalToken.short_names/0","doc":"Returns a mapping of digital token short names to digital token identifiers.","ref":"DigitalToken.html#short_names/0"},{"type":"function","title":"DigitalToken.symbol/2","doc":"Returns a currency symbol used in number formatting. Arguments token_id is any validate digital token identifier. style is a number in the range 1 to 4 as follows: 1 is the token's symbol, if it exists 2 is the token's short name as a proxy for a currency code 3 is the token's long name 4 is the token's symbol as a proxy for a narrow currency symbol Returns {:ok, symbol} or {:error, {exception, reason}} Examples iex&gt; DigitalToken . symbol &quot;BTC&quot; , 1 { :ok , &quot;₿&quot; } iex&gt; DigitalToken . symbol &quot;BTC&quot; , 2 { :ok , &quot;BTC&quot; } iex&gt; DigitalToken . symbol &quot;BTC&quot; , 3 { :ok , &quot;Bitcoin&quot; } iex&gt; DigitalToken . symbol &quot;BTC&quot; , 4 { :ok , &quot;₿&quot; } iex&gt; DigitalToken . symbol &quot;ETH&quot; , 4 { :ok , &quot;Ξ&quot; } iex&gt; DigitalToken . symbol &quot;DOGE&quot; , 4 { :ok , &quot;Ð&quot; } iex&gt; DigitalToken . symbol &quot;DODGY&quot; , 4 { :error , { DigitalToken.UnknownTokenError , &quot;DODGY&quot; } }","ref":"DigitalToken.html#symbol/2"},{"type":"function","title":"DigitalToken.symbols/0","doc":"Returns a mapping of digital token identifiers names to a currency symbol.","ref":"DigitalToken.html#symbols/0"},{"type":"function","title":"DigitalToken.tokens/0","doc":"Returns a map of the digital tokens in the dtif registry .","ref":"DigitalToken.html#tokens/0"},{"type":"function","title":"DigitalToken.validate_token/1","doc":"Validates a token identifier or short name and returns the token identifier or an error. Arguments id is any token identifier or short name Returns {:ok, token_id} or {:error, {exception, id}} Example iex&gt; DigitalToken . validate_token ( &quot;BTC&quot; ) { :ok , &quot;4H95J0R2X&quot; } iex&gt; DigitalToken . validate_token ( &quot;Bitcoin&quot; ) { :ok , &quot;4H95J0R2X&quot; } iex&gt; DigitalToken . validate_token &quot;4H95J0R2X&quot; { :ok , &quot;4H95J0R2X&quot; } iex&gt; DigitalToken . validate_token ( &quot;Nothing&quot; ) { :error , { DigitalToken.UnknownTokenError , &quot;Nothing&quot; } }","ref":"DigitalToken.html#validate_token/1"},{"type":"type","title":"DigitalToken.short_name/0","doc":"A digital token may have zero of more short names associated with it. They are arbitrary strings, usually three or four characters in length. For example &quot;BTC&quot;, &quot;ETH&quot; and &quot;DOGE&quot;.","ref":"DigitalToken.html#t:short_name/0"},{"type":"type","title":"DigitalToken.short_name_map/0","doc":"A mapping from a short name to token identifier.","ref":"DigitalToken.html#t:short_name_map/0"},{"type":"type","title":"DigitalToken.symbol_map/0","doc":"A mapping of digital token identifiers to a currency symbol for that token.","ref":"DigitalToken.html#t:symbol_map/0"},{"type":"type","title":"DigitalToken.t/0","doc":"The structure of data matching that hosted in the DTIF registry /","ref":"DigitalToken.html#t:t/0"},{"type":"type","title":"DigitalToken.token_id/0","doc":"token_id is a random 9-character string defined by the dtif registry that uniquely identifies a digital token.","ref":"DigitalToken.html#t:token_id/0"},{"type":"type","title":"DigitalToken.token_map/0","doc":"A mapping of digital token identifiers to the registry data for that token.","ref":"DigitalToken.html#t:token_map/0"},{"type":"type","title":"DigitalToken.token_type/0","doc":"The type of a token","ref":"DigitalToken.html#t:token_type/0"},{"type":"module","title":"DigitalToken.Config","doc":"","ref":"DigitalToken.Config.html"},{"type":"function","title":"DigitalToken.Config.json_library/0","doc":"Return the configured json lib","ref":"DigitalToken.Config.html#json_library/0"},{"type":"task","title":"Mix.Tasks.DigitalToken.Registry.Update","doc":"Updates the digital token registry data.","ref":"Mix.Tasks.DigitalToken.Registry.Update.html"},{"type":"task","title":"Mix.Tasks.DigitalToken.Symbols.Update","doc":"Updates the digital token symbols data. Data is copied from Crypto Currency Symbols .","ref":"Mix.Tasks.DigitalToken.Symbols.Update.html"},{"type":"exception","title":"DigitalToken.UnknownTokenError","doc":"Exception raised when a digital token is unknown.","ref":"DigitalToken.UnknownTokenError.html"},{"type":"extras","title":"Digital Token","doc":"ISO 24165 introduces a common language for digital currencies. Up until now, digital currencies (&quot;crypto&quot;) have been an uncomfortable fit into the world of currencies which are governed by ISO 4217 . ISO 4217 does allow for private use currencies, however in common use several crypto currencies use unnoficial ISO 4217 codes that clash with the standard. The introduction of ISO 24165 (and is relationship to ISO 20022 ) creates a framework for the identification and standardisation of digital tokens. In addition, the Digital Token Identification Foundation (DTIF) has been formed to operate a registry of tokens with downloadable data making it easy to access and integrate the data into applications. This library provides a means to download and access the digital token registry. One application is the upcoming integration of digital_token into ex_money providing money operations on both ISO 4217 currencies and ISO 24165 digital tokens. Digital Token Identifier Format The basic number is eight characters (alphanumeric) in length but excludes vowels (A, E, I, O, U) and the letter Y, and zero shall not be the first character. A ninth character is added and is calculated as a checksum. Non-ISO 4217 cryptocurrency codes The following are examples of commonly-used but non-compliant ISO 4217 currency codes. This, plus the inherent flux in the number of digital currencies gave rise to ISO 24165 . Unofficial code Digits Currency Notes ADA 6 Ada ADA conflicts with ISO 4217, because AD stands for Andorra. BNB 8 Binance BNB BNB conflicts with ISO 4217, because BN stands for Brunei Darussalam. BSV 8 Bitcoin SV BSV conflicts with ISO 4217, because BS stands for Bahamas. BTC, XBT 8 Bitcoin XBT conflicts with ISO 4217, because BT stands for Bhutan. DASH 8 Dash DASH is of non-standard length. DOGE 4 Dogecoin DOGE is of non-standard length. ETH 18 Ethereum ETH conflicts with ISO 4217, because ET stands for Ethiopia. LTC 8 Litecoin LTC conflicts with ISO 4217, because LT stands for Lithuania. Installation The package can be installed by adding digital_token to your list of dependencies in mix.exs : def deps do [ { :digital_token , &quot;~&gt; 0.2.0&quot; } ] end The docs can be found at https://hexdocs.pm/digital_token . Configuration DigitalToken requires that a JSON library be configuration that provides a decode!/1 function. Common libraries sucn as poison , jason and jsonrs are good examples. A JSON library can be configured on config.exs like this: config :digital_token , json_library : Jason Note that the configuration parameter is the module upon which the decode!/1 function is available. If no configuration is set, DigitalToken will attempt to use Jason , Poison , the JSON library configuration for ecto or the JSON library configured for Phoenix .","ref":"readme.html"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - Digital Token 0.6.0","doc":"This is the changelog for Digital Token version 0.6.0 released on July 8th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Remove checking Phoenix and Ecto json_library configurations. Ecto no longer configures its :json_library in config.exs and checking for Phoenix configuration can cause config failures when building in Docker . Sort the short names for a token by their length so that the standard short name is the shortest one. Fix code that made an implicit assumption about map order. Enhancements Update to the latest toekn registry and symbol registry.","ref":"changelog.html#digital-token-0-6-0"},{"type":"extras","title":"Changelog - Digital Token 0.5.0","doc":"This is the changelog for Digital Token version 0.5.0 released on June 22nd, 2023. For older changelogs please consult the release tag on GitHub Enhancements Make the JSON library configurable. Like ex_cldr it will also attempt to use the JSON library configured for ex_cldr , ecto , phoenix or if otherwise configured Jason or Poison .","ref":"changelog.html#digital-token-0-5-0"},{"type":"extras","title":"Changelog - Digital Token 0.3.0","doc":"This is the changelog for Digital Token version 0.3.0 released on May 14th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Add DigitalToken.short_name/1 to return the short name of the digital token. This is analogous to the currency code for a currency. Add DigitalToken.long_name/1 to return the long name of the digital token. This is analogous to the name of a currency. Add DigitalToken.symbol/2 to return a &quot;currency&quot; symbol for a digital token that will be used for number formatting in ex_cldr_numbers and ex_money .","ref":"changelog.html#digital-token-0-3-0"},{"type":"extras","title":"Changelog - Digital Token 0.2.0","doc":"This is the changelog for Digital Token version 0.2.0 released on May 9th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Return only the token id from DigitalToken.validate_token/1 when the argument is already a valid token identifier.","ref":"changelog.html#digital-token-0-2-0"},{"type":"extras","title":"Changelog - Digital Token 0.1.0","doc":"This is the changelog for Digital Token version 0.1.0 released on May 8th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Initial release","ref":"changelog.html#digital-token-0-1-0"},{"type":"extras","title":"License","doc":"Copyright 2022 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]